#include <iostream>
#include <fstream>

using namespace std;

struct GeriausiasPasiekimas{
    string sportininkoKodas;
    double olimpiniuRezultatas;
    double rezultatas;
    int data;
    string valstybe;
    double skirtumasNuoOlimpiniu;
};

//Ši funkcija bus naudojama abiejų rezultatų grupių vidurkių skaičiavimui, todėl parametru perduosime skaičių masyvą ir gražinsime vidurkio reikšmę tolimesniems skaičiavimams
double gautiRezultatuVidurki(double rezultatai[], int rezultatuKiekis, ofstream& failasRezultatai){
    double rezultatuSuma = 0.0;
    double rezultatuVidurkis = 0.0;

    for (int i = 0; i < rezultatuKiekis; i++){
        rezultatuSuma += rezultatai[i];
    }

    rezultatuVidurkis = rezultatuSuma / rezultatuKiekis;

    failasRezultatai << "Vidutiniškai diskas skriejo " << rezultatuVidurkis << " m." << endl;

    return rezultatuVidurkis;
}

void gautiRezultatuVidurkiuMinMaxSkirtuma(GeriausiasPasiekimas rezultatai[], int rezultatuKiekis, ofstream& failasRezultatai){
    double minRezultatas = rezultatai[0].olimpiniuRezultatas;
    double maxRezultatas = rezultatai[0].olimpiniuRezultatas;
    double minMaxSkirtumas = 0.0;

    for (int i = 0; i < rezultatuKiekis; i++){
        if (rezultatai[i].olimpiniuRezultatas < minRezultatas){
            minRezultatas = rezultatai[i].olimpiniuRezultatas;
        }

        if (rezultatai[i].olimpiniuRezultatas > maxRezultatas){
            maxRezultatas = rezultatai[i].olimpiniuRezultatas;
        }
    }

    minMaxSkirtumas = maxRezultatas - minRezultatas;

    failasRezultatai << "Skirtumas tarp didžiausio ir mažiausio rezultato " << minMaxSkirtumas << " m." << endl;
}

string gautiPavarde(string sportininkoKodas){
   return sportininkoKodas.substr(1);
}

int gautiMetus (int data){
    int metai = data / 10000;
    return metai;
}

void gautiSeniausiaGeriausiaRezultata(GeriausiasPasiekimas geriausiPasiekimai[], int rezultatuKiekis, ofstream& failasRezultatai){
    int seniausiMetai = gautiMetus(geriausiPasiekimai[0].data);
    int seniausiasIndeksas = 0;

    for (int i = 0; i < rezultatuKiekis; i++){
        if (gautiMetus(geriausiPasiekimai[i].data) < seniausiMetai){
            seniausiMetai = gautiMetus(geriausiPasiekimai[i].data);
            seniausiasIndeksas = i;
        }
    }

    failasRezultatai
        << gautiPavarde(geriausiPasiekimai[seniausiasIndeksas].sportininkoKodas)
        << " "
        << geriausiPasiekimai[seniausiasIndeksas].rezultatas
        << " "
        << gautiMetus(geriausiPasiekimai[seniausiasIndeksas].data)
        << " "
        << geriausiPasiekimai[seniausiasIndeksas].valstybe
        << endl;
}

void isrikiuotiPagalSkirtumaNuoOlimpiniu(GeriausiasPasiekimas geriausiPasiekimai[], int rezultatuKiekis, ofstream& failasRezultatai){
    GeriausiasPasiekimas isrusiuotiGeriausiPasiekimai[32];
    GeriausiasPasiekimas tempPasiekimas; //kintamasis dviejų masyvo reikšmių sukeitimui
    // mažėjantis slenkstis kiekvienai iteracijai, iki kurio elemento reikia rūšiuoti burbuliuku
    int rusiavimoRiba;

    //Suskaičiuojam kiekvieno sportininko skirtumą
    for (int i = 0; i < rezultatuKiekis; i++){
       geriausiPasiekimai[i].skirtumasNuoOlimpiniu = geriausiPasiekimai[i].rezultatas - geriausiPasiekimai[i].olimpiniuRezultatas;
       isrusiuotiGeriausiPasiekimai[i] = geriausiPasiekimai[i];
    }

    //Išrūšiuojam burbuliuko metodu
    rusiavimoRiba = rezultatuKiekis;
    for (int j = 0; j < rezultatuKiekis-1; j++){
        rusiavimoRiba--;
        for (int i = 0; i < rusiavimoRiba; i++){
            if (isrusiuotiGeriausiPasiekimai[i+1].skirtumasNuoOlimpiniu < isrusiuotiGeriausiPasiekimai[i].skirtumasNuoOlimpiniu){
                tempPasiekimas = isrusiuotiGeriausiPasiekimai[i];
                isrusiuotiGeriausiPasiekimai[i] = isrusiuotiGeriausiPasiekimai[i+1];
                isrusiuotiGeriausiPasiekimai[i+1] = tempPasiekimas;
            }
        }
    }
    //rezultatų įrašymas į failą
    for (int i = 0; i < rezultatuKiekis; i++){
        failasRezultatai << gautiPavarde(isrusiuotiGeriausiPasiekimai[i].sportininkoKodas) << " " << isrusiuotiGeriausiPasiekimai[i].skirtumasNuoOlimpiniu << " m" << endl;
    }
}

int main()
{
    int eiluciuKiekisFaile;
    double olimpiniuVidurkis, geriausiuPasiekimuVidurkis;

    //Masyvo dydį nurodome pagal sąlygą - iš viso dalyvavusių sportininkų skaičių
    GeriausiasPasiekimas geriausiPasiekimai[32];
    double rezultataiSkaiciavimams[32];

    //Į struktūrų masyvą nuskaitome csv failą
    char tempSimbolis;
    string sportininkoKodas = "";
    eiluciuKiekisFaile = 0;

    fstream failasPasiekimai("Pasiekimai.csv");
    while (!failasPasiekimai.eof()){
        getline(failasPasiekimai, sportininkoKodas, ';');
        if (!failasPasiekimai.eof()){
            geriausiPasiekimai[eiluciuKiekisFaile].sportininkoKodas = sportininkoKodas;
            failasPasiekimai
                >> geriausiPasiekimai[eiluciuKiekisFaile].olimpiniuRezultatas >> tempSimbolis
                >> geriausiPasiekimai[eiluciuKiekisFaile].rezultatas >> tempSimbolis
                >> geriausiPasiekimai[eiluciuKiekisFaile].data >> tempSimbolis
                >> geriausiPasiekimai[eiluciuKiekisFaile].valstybe >> ws;
            eiluciuKiekisFaile++;
        }
    }
    failasPasiekimai.close();

    //Paruošiamas Rezultatų failas
    ofstream failasRezultatai("Rezultatai.txt");
    failasRezultatai << "Disko metimo duomenų analizės rezultatai:" << endl << endl << "Olimpinės žaidynės:" << endl;

    //Persikeliame olimpinių žaidynių rezultatus į skaičių masyvą, vidurkio skaičiavimui
    for (int i = 0; i <  eiluciuKiekisFaile; i++){
        rezultataiSkaiciavimams[i] = geriausiPasiekimai[i].olimpiniuRezultatas;
    }

    //Paskaičiuojame ir įrašome į failą olimpinių žaidynių rezultatų vidurkį
    olimpiniuVidurkis = gautiRezultatuVidurki(rezultataiSkaiciavimams, eiluciuKiekisFaile, failasRezultatai);
    gautiRezultatuVidurkiuMinMaxSkirtuma(geriausiPasiekimai, eiluciuKiekisFaile, failasRezultatai);

    failasRezultatai << endl << "Geriausi rezultatai:" << endl;

    //Persikeliame geriausius ikiolimpinius rezultatus į tą patį skaičių masyvą, vidurkio skaičiavimui
    for (int i = 0; i <  eiluciuKiekisFaile; i++){
        rezultataiSkaiciavimams[i] = geriausiPasiekimai[i].rezultatas;
    }
    //Paskaičiuojame ir įrašome į failą geriausių ikiolimpinių rezultatų vidurkį
    geriausiuPasiekimuVidurkis = gautiRezultatuVidurki(rezultataiSkaiciavimams, eiluciuKiekisFaile, failasRezultatai);

    failasRezultatai << "Vidurkis ";
    if (geriausiuPasiekimuVidurkis > olimpiniuVidurkis){
        failasRezultatai << geriausiuPasiekimuVidurkis - olimpiniuVidurkis << " m didesnis negu olimpinėse žaidynėse." << endl;
    } else {
        failasRezultatai << olimpiniuVidurkis - geriausiuPasiekimuVidurkis << " m mažesnis negu olimpinėse žaidynėse." << endl;
    }

    failasRezultatai << endl << "Seniausiai pasiektas geriausias rezultatas:" << endl;

    gautiSeniausiaGeriausiaRezultata(geriausiPasiekimai, eiluciuKiekisFaile, failasRezultatai);

    failasRezultatai << endl << "Skirtumas tarp sportininkų pasiekimų:" << endl;

    isrikiuotiPagalSkirtumaNuoOlimpiniu(geriausiPasiekimai, eiluciuKiekisFaile, failasRezultatai);

    failasRezultatai.close();

    return 0;
}
